#include "convert.h"
#include "constant\constant.h"

using namespace System;


namespace TechnoAP { namespace usbmca {

	namespace common
	{
		/// <summary>
		/// Nano seconds -> count conversion
		/// </summary>
		__int64 convert::NanosecondsToCount(__int64 value)
		{
			__int64 result = value / TechnoAP::usbmca::constant::Unit::CountPerDigitNsec;
			return result;
		}

		/// <summary>
		/// Milliseconds -> count conversion
		/// </summary>
		__int64 convert::MillisecondsToCount(__int64 value)
		{
			return NanosecondsToCount(value * 1000000ll);
		}

		/// <summary>
		/// Seconds -> count conversion
		/// </summary>
		__int64 convert::SecondsToCount(__int64 value)
		{
			return MillisecondsToCount(value * 1000ll);
		}

		// count -> time
		/// <summary>
		/// Count -> nano seconds conversion
		/// </summary>
		__int64 convert::CountToNanoseconds(__int64 count)
		{
			return (count * TechnoAP::usbmca::constant::Unit::CountPerDigitNsec);
		}

		/// <summary>
		/// Count -> milliseconds conversion
		/// </summary>
		__int64 convert::CountToMilliseconds(__int64 count)
		{
			return (CountToNanoseconds(count) / 1000000ll);
		}
	}
} }


