#pragma once

#include "device.h"
#include "constant\constant.h"

using namespace System;


namespace TechnoAP { namespace usbmca {

	using namespace FTD2XX_NET;
	using namespace TechnoAP::usbmca::device;
	using namespace TechnoAP::usbmca::constant;

	namespace device
	{
		/// <summary>
		/// Summary for config
		/// </summary>
		public ref class config
		{
		public:
			device ^mDevice = nullptr;

			array<unsigned int> ^manADG = gcnew array<unsigned int>(constant::Max::CH);
			array<unsigned int> ^manTHR = gcnew array<unsigned int>(constant::Max::CH);
			array<unsigned int> ^manLLD = gcnew array<unsigned int>(constant::Max::CH);
			array<unsigned int> ^manULD = gcnew array<unsigned int>(constant::Max::CH);
			array<unsigned int> ^manOFS = gcnew array<unsigned int>(constant::Max::CH);
			array<unsigned int> ^manIOF = gcnew array<unsigned int>(constant::Max::CH);
			array<unsigned int> ^manIFG = gcnew array<unsigned int>(constant::Max::CH);

			PdsMode muPDS;
			
		public:
			config() { return; }
			config(device ^clsDevice);

		public:
			void SetADG(array<unsigned int> ^value) { CopyConfigData(value, manADG); }
			void SetTHR(array<unsigned int> ^value) { CopyConfigData(value, manTHR); }
			void SetLLD(array<unsigned int> ^value) { CopyConfigData(value, manLLD); }
			void SetULD(array<unsigned int> ^value) { CopyConfigData(value, manULD); }
			void SetOFS(array<unsigned int> ^value) { CopyConfigData(value, manOFS); }
			void SetIOF(array<unsigned int> ^value) { CopyConfigData(value, manIOF); }
			void SetIFG(array<unsigned int> ^value) { CopyConfigData(value, manIFG); }

			void SetADG(UInt32 uCh1, UInt32 uCh2, UInt32 uCh3, UInt32 uCh4) { CopyConfigData(manADG, uCh1, uCh2, uCh3, uCh4); }
			void SetTHR(UInt32 uCh1, UInt32 uCh2, UInt32 uCh3, UInt32 uCh4) { CopyConfigData(manTHR, uCh1, uCh2, uCh3, uCh4); }
			void SetLLD(UInt32 uCh1, UInt32 uCh2, UInt32 uCh3, UInt32 uCh4) { CopyConfigData(manLLD, uCh1, uCh2, uCh3, uCh4); }
			void SetULD(UInt32 uCh1, UInt32 uCh2, UInt32 uCh3, UInt32 uCh4) { CopyConfigData(manULD, uCh1, uCh2, uCh3, uCh4); }
			void SetOFS(UInt32 uCh1, UInt32 uCh2, UInt32 uCh3, UInt32 uCh4) { CopyConfigData(manOFS, uCh1, uCh2, uCh3, uCh4); }
			void SetIOF(UInt32 uCh1, UInt32 uCh2, UInt32 uCh3, UInt32 uCh4) { CopyConfigData(manIOF, uCh1, uCh2, uCh3, uCh4); }
			void SetIFG(UInt32 uCh1, UInt32 uCh2, UInt32 uCh3, UInt32 uCh4) { CopyConfigData(manIFG, uCh1, uCh2, uCh3, uCh4); }

			void SetPDS(PdsMode uPDS)
			{
				muPDS = uPDS;
			}

		public:
			static void CopyConfigData(array<unsigned int> ^source, array<unsigned int> ^destination);
			static void CopyConfigData(array<unsigned int> ^destination, UInt32 uCh1, UInt32 uCh2, UInt32 uCh3, UInt32 uCh4);

		public:
			bool Write(void);


		};

	}
} }



