#pragma once

#include "status.h"
#include "data\histogram.h"
#include "constant\constant.h"

using namespace System;


namespace TechnoAP { namespace usbmca {

	using namespace FTD2XX_NET;
	using namespace TechnoAP::usbmca::data;

	namespace device
	{
		/// <summary>
		/// Summary for device
		/// </summary>
		public ref class device : FTD2XX_NET::FTDI
		{
		public:
			static device(void);

		public:
			FT_STATUS ^mLastStatus = nullptr;
			String ^mLastCommand = String::Empty;
			unsigned int mLastWriteCommandValue = 0;
			unsigned int mLastReadCommandValue = 0;
			int mnErrorReadList = 0;

		private:
			unsigned int mInputDummy = 0;
			unsigned int mOutputDummy = 0;

		public:
			TechnoAP::usbmca::device::status ^mStatus = gcnew TechnoAP::usbmca::device::status();
			array<unsigned int, 2> ^maHistogram = gcnew array<unsigned int, 2>(constant::Max::CH, constant::Size::HistogramMaxCh);

		public:
			bool WriteCommand(String ^command, int channel, unsigned int value);
			bool ReadCommand(String ^%command, unsigned int %value);
			bool OrderCommand(String ^command, int channel, unsigned int input, unsigned int %output);
			bool StartMeasurement(void);
			bool StopMeasurement(void);
			bool ClearMeasurementData(void);
			bool SetMeasurementDataMode(constant::DataMode value);
			bool SetMeasurementTimeMode(constant::TimeMode value);
			bool SetMeasurementTime(__int64 value);
			bool SetMeasurementTimeSeconds(__int64 value);
			bool SetMeasurementTimeMiilliseconds(__int64 value);
			status^ ReadStatus(void);
			array<Byte>^ ReadListData(int %nReadBytes);
			array<unsigned int>^ ReadHistogram(int channel, int maxch);



		};

	}
} }



